/*
################################################################################
# remoteMethod.java
#
# Copyright (C) 2007 Fernando G. Tinetti
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
################################################################################
 *
 * remoteMethod.java
 *    Interface defined for the class with the remote methods to be
 *    used from the "client" side and implemented on the "server". 
 *    Thus, only the four methods (access/leave Reader/Writer) are 
 *    defined, all of them throwing RemoteException
 */

import java.rmi.Remote;              /* Required for being remote... */
import java.rmi.RemoteException;     /* Required for being remote... */

public interface remoteMethod extends Remote
{
  /* The four methods needed for the readers/writers problem */
  public Boolean accessReader() throws RemoteException;
  public Boolean accessWriter() throws RemoteException;
  public Boolean leaveReader() throws RemoteException;
  public Boolean leaveWriter() throws RemoteException;
}
